package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.UserRoleDetailService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.UserRoleDetail;
import com.sa.ibiz.demo.demo.service.dto.UserRoleDetailSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/userroledetail")
public class UserRoleDetailController{



    @Autowired
	private UserRoleDetailService userroledetailService;
	/**
	 * 获取服务对象
	*/
	protected UserRoleDetailService getService(){
		return this.userroledetailService;
	}



	@PostMapping(value="maineditform/update")
	public ResponseEntity<UserRoleDetail_EditForm_Main> mainEditFormUpdate(@Validated @RequestBody UserRoleDetail_EditForm_Main form){
            UserRoleDetail entity =form.toUserRoleDetail();
            getService().update(entity);
            form.fromUserRoleDetail(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/remove")
	public ResponseEntity<UserRoleDetail_EditForm_Main> mainEditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserRoleDetail_EditForm_Main form=new UserRoleDetail_EditForm_Main();
            UserRoleDetail entity = new UserRoleDetail();
            entity.setUserroledetailid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromUserRoleDetail(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/getdraft")
	public ResponseEntity<UserRoleDetail_EditForm_Main> mainEditFormGetDraft(@RequestBody UserRoleDetail_EditForm_Main form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            UserRoleDetail sourceEntity =new UserRoleDetail();
            sourceEntity.setUserroledetailid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			UserRoleDetail targetEntity =new UserRoleDetail();
			sourceEntity.copyTo(targetEntity);
			form.fromUserRoleDetail(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            UserRoleDetail entity =form.toUserRoleDetail();
            getService().getDraft(entity);
            form.fromUserRoleDetail(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="maineditform/get")
	public ResponseEntity<UserRoleDetail_EditForm_Main> mainEditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            UserRoleDetail_EditForm_Main form=new UserRoleDetail_EditForm_Main();
            UserRoleDetail entity = new UserRoleDetail();
            entity.setUserroledetailid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromUserRoleDetail(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="maineditform/create")
	public ResponseEntity<UserRoleDetail_EditForm_Main> mainEditFormCreate(@Validated @RequestBody UserRoleDetail_EditForm_Main form){
            UserRoleDetail entity =form.toUserRoleDetail();
            getService().create(entity);
            form.fromUserRoleDetail(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.UserRoleService userroleService;
	@PostMapping(value="maineditform/uesrrolename/ac")
	public ResponseEntity<List<AutoCompleteItem>> mainEditForm_uesrrolename_ac(@RequestBody UserRoleDetail_EditForm_Main form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.UserRoleSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.UserRoleSearchFilter();
		UserRoleDetail entity =form.toUserRoleDetail();
		String queryField=entity.getUesrrolename();
		searchFilter.getSelectCond().like("userrolename",queryField);
		Page<com.sa.ibiz.demo.demo.domain.UserRole> searchResult = userroleService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.UserRole entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getUserroleid());
			acItem.setText(entity2.getUserrolename());
			acItem.setRealtext(entity2.getUserrolename());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@Autowired
	private com.sa.ibiz.demo.demo.service.UserObjectService userobjectService;
	@PostMapping(value="maineditform/userobjectname/ac")
	public ResponseEntity<List<AutoCompleteItem>> mainEditForm_userobjectname_ac(@RequestBody UserRoleDetail_EditForm_Main form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.UserObjectSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.UserObjectSearchFilter();
		UserRoleDetail entity =form.toUserRoleDetail();
		String queryField=entity.getUserobjectname();
		searchFilter.getSelectCond().like("userobjectname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.UserObject> searchResult = userobjectService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.UserObject entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getUserobjectid());
			acItem.setText(entity2.getUserobjectname());
			acItem.setRealtext(entity2.getUserobjectname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@PostMapping(value="main2grid/update")
	public UserRoleDetail main2GridUpdate(@Validated UserRoleDetail main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/remove")
	public ResponseEntity<UserRoleDetail> main2GridRemove(@Validated @RequestBody Map args){
	    UserRoleDetail entity =new UserRoleDetail();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setUserroledetailid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public UserRoleDetail main2GridGet(String userroledetailid){
		return null;
	}
	@PostMapping(value="main2grid/getdraft")
	public UserRoleDetail main2GridGetDraft(@Validated UserRoleDetail main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/create")
	public UserRoleDetail main2GridCreate(@Validated UserRoleDetail main2Item){
		return main2Item;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main2]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="main2grid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> main2gridExportDataSearchDefault(@Validated @RequestBody UserRoleDetailSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<UserRoleDetail> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=UserRoleDetail_Grid_Main2.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=UserRoleDetail_Grid_Main2.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=UserRoleDetail_Grid_Main2.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="main2grid/searchdefault")
	public ResponseEntity<Page<UserRoleDetail_Grid_Main2>> main2GridSearchDefault(@Validated @RequestBody UserRoleDetailSearchFilter searchFilter){
			Page<UserRoleDetail> searchResult = this.getService().searchDefault(searchFilter);
			Page<UserRoleDetail_Grid_Main2> searchResult_vo_data =UserRoleDetail_Grid_Main2.fromUserRoleDetail(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<UserRoleDetail_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody UserRoleDetail_SearchForm_Default searchform){
 		 
			UserRoleDetailSearchFilter searchfilter =searchform.toUserRoleDetailSearchFilter();
			searchform.fromUserRoleDetailSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }